/************************************************************************
*									*
*	DMX Dongle utility  V1.2  		  			*
*									*
*	(C) Copyright Artistic Licence (UK) Ltd 1995-96			*
*                                                                       *
*	NOT FOR DISTRIBUTION WITHOUT WRITTEN PERMISSION			*
*									*
*       Author W D Howell						*
*									*
*-----------------------------------------------------------------------*
*									*
*       ported to Linux by Michael Stickel (michael@cubic.org)		*
*									*
************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <sys/io.h>
#include <sys/time.h>

#include "dongle.h"

unsigned long GetTime ()
{
  struct timeval tv;
  if (gettimeofday (&tv, NULL)) 
    return 0L;
  return tv.tv_usec + tv.tv_sec*1000000;
}

void exit_app()
{
  ioperm (0x378, 8, 0);
  ioperm (0x278, 8, 0);
  ioperm (0x3bc, 3, 0);
  end_dongle();
}


char trial(unsigned int addr)
{
  long start_time;
  char count=100;

  if(init_dongle(addr)==0x5)
  {
    printf("DMX-Dongle found at address 0x%x\r\n",addr);
    printf("Dongle type number = %d\r\n",get_dongle_type());
    printf("Dongle firmware revision = %d\r\n\r\n",get_firmware());

    printf("Please Wait for Benchmark.\r\n ");
    //clr_memory();
    start_time = GetTime ();

    while(count--)
      tx_dmx(1);

    printf("This PC requires %imS to transmit a full DMX frame.\r\n\r\n ",
      (int)((GetTime ()-start_time)/1000)/100);
    
    end_dongle();
    return(YES);
  }
  return(NO);
}

int main(int argc, char **argv)
{
  int port=0;

  if(argc>=2)
    port=strtol(argv[1], 0, 0);

  if(port>0 && port<0x10000)
    {
      if(iopl(3) < 0)
	{
	  perror("could get permisson for ioport");
	  return 1;
	}
      else
	{
	  printf("checking port 0x%X... ", port); fflush(stdout);
	  if(trial(port)) 
	    {
	      return 0;
	    }
	  printf("no DMX-Dongle found\n");
	  return 1;
	}

    }

  if(ioperm (0x378, 8, 1) < 0)
    {
      perror("could not get permission for port 1");
    }
  else
    {
      printf("checking port 1... "); fflush(stdout);
      if(trial(0x378)) 
	{
	  return 0;
	}
      printf("no DMX-Dongle found\n");
    }

  if(ioperm (0x278, 8, 1) < 0)
    {
      perror("could not get permission for port 2");
    }
  else
    {
      printf("checking port 2... "); fflush(stdout);
      if(trial(0x278)) 
	{
	  return 0;
	}
      printf("no DMX-Dongle found\n");
    }

  if(ioperm (0x3bc, 3, 1) < 0)
    {
      perror("could not get permission for port 0");
    }
  else
    {
      printf("checking port 0... "); fflush(stdout);
      if(trial(0x3bc)) 
	{
	  return 0;
	}
      printf("no DMX-Dongle found\n");
    }

  return 0;
}
